#include "3dfx/vbdefs.h"

enum tcardtype { none_3dfx = 0, banshee_3dfx , voodoo3_3dfx } ;

struct chipset_private {
  enum tcardtype type ; 
  struct kgi_chipset chipset_info ; 
  /* kgiu32 IOAddress,MemBase,IOBase ;  */
  /* kgiu32 PhysIOAddress,PhysMemBase,PhysIOBase ; */
  struct mem_region bank0 ;
  struct mem_region bank1 ;
  struct io_region iobank ;
  struct kgi_mmio_region mmio ;

  kgiu32 vidpll ;  /* The value to put in the PLLCTRL0 register (see the clock setup ) */
}  ;  

#define NoSEQRegs	0x05
#define	NoCRTRegs	0x19
#define NoGRCRegs	0x09
#define NoATCRegs	0x15
#define NoExtVgaRegs	0x02

struct statetable
{
  kgiu8 MISC;
  kgiu8 SEQ[NoSEQRegs];
  kgiu8 CRT[NoCRTRegs];
  kgiu8 GRC[NoGRCRegs];
  kgiu8 ATC[NoATCRegs];
  kgiu8 ExtVga[NoExtVgaRegs];

  /* banshee registers */
  kgiu32 vidcfg;
  kgiu32 vidpll;
  kgiu32 mempll;
  kgiu32 gfxpll;
  kgiu32 dacmode;
  kgiu32 vgainit0;
  kgiu32 vgainit1;
  kgiu32 screensize;
  kgiu32 stride;
  kgiu32 cursloc;
  kgiu32 startaddr;

};



#define GET_PRIVATE \
	struct chipset_private *private = KGIM_PRIVATE(dpy, chipset)


#if 0
#define BANSHEE_MAX_CLOCK 270000000
#else
#define BANSHEE_MAX_CLOCK 135000000
#endif

#define TYPE          (private->type)
#define	CHIPSET_INFO  (private->chipset_info)
#define	VIDPLL        (private->vidpll)

#define BANK0         (private->bank0)
#define IOMEMBASE     (BANK0.baseptr)
#define PIOMEMBASE    (BANK0.base)
#define IOMEMSIZE     (BANK0.size)

#define BANK1         (private->bank1)
#define MEMBASE       (BANK1.baseptr)
#define PMEMBASE      (BANK1.base)
#define MEMSIZE       (BANK1.size)

#define IOBANK        (private->iobank)
#define IOBASE        (IOBANK.baseptr)
#define PIOBASE       (IOBANK.base)
#define IOSIZE        (IOBANK.size)

#define MMIO      (private->mmio)

#define MANUFACT      (CHIPSET_INFO.manufact)
#define MODEL         (CHIPSET_INFO.model)
#define MODES         (CHIPSET_INFO.modes)
#define MAXDOTS       (CHIPSET_INFO.maxdots)
#define FLAGS         (CHIPSET_INFO.flags)
#define RAMSIZE       (CHIPSET_INFO.ramsize)


void save_state(struct kgi_display *dpy,struct statetable *state) ;
void restore_state(struct kgi_display *dpy,struct statetable *state) ;

